#!/bin/bash

LOGFILE=mwcap_sdk_install.log

#echo "================="
#echo "	check root "
#echo "================="
if [ `id -u` -ne 0 ] ; then
    sudo su -c "$0 $*"
    exit $?
fi

SDKDIR=`pwd`/..
LOGFILE=mwcap_sdk_install.log
MODUEL_INSTALL_DIR=/usr/local/share/ProCaptureSDK
MODUEL_INCLUDE_DIR=/usr/include/ProCaptureSDK
remove_module ()
{
	cd $MODUEL_INSTALL_DIR
	for binname in `ls $MODUEL_INSTALL_DIR/bin`; 
	do
        	if [ -h /usr/bin/$binname ];
		then
            		rm -vf /usr/bin/$binname >> "$SDK_DIR/$LOGFILE" 2>&1
        	fi
	done
	
	cd $MODUEL_INSTALL_DIR
	for libname in `ls $MODUEL_INSTALL_DIR/lib`; 
	do
        	if [ -h /usr/lib/$libname ];
		then
            		rm -vf /usr/lib/$libname >> "$SDK_DIR/$LOGFILE" 2>&1
        	fi
	done

    	if [ -d $MODUEL_INSTALL_DIR ]; 
	then
        	echo "Removing installed files ... "
        	rm -vrf $MODUEL_INSTALL_DIR >> "$SDK_DIR/$LOGFILE" 2>&1
        	echo "Done."
	fi

    	if [ -h /usr/bin/mwcapsdk-uninstall.sh ]; 
	then
        	rm -vf /usr/bin/mwcapsdk-uninstall.sh >> "$SDK_DIR/$LOGFILE" 2>&1
    	fi
	
	if [ -d $MODUEL_INCLUDE_DIR ];
	then
		rm -vrf $MODUEL_INCLUDE_DIR >> "$SDK_DIR/$LOGFILE" 2>&1
	fi
}

remove_module

echo "Uninstall Successfully!"
echo ""
