#ifndef ALSADEVICEINFO_H
#define ALSADEVICEINFO_H
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <alsa/asoundlib.h>
#include <stdbool.h>
#include <dirent.h>
#include <fnmatch.h>

#include "win-types.h"
#include "mw-common.h"
#include "lib-mw-capture.h"

#define MAX_ALSA_DEVICE_NUM     64
#define MAX_HW_NAME_LEN         32
#define MAX_PA_NAME_LEN         64
#define MAX_PCM_NAME_LEN        64

typedef struct _PRO_CAPTURE__ALSA_DEVICE_INFO_
{
    char            szHwName[MAX_HW_NAME_LEN];
    char            szPaName[MAX_PA_NAME_LEN];
} PRO_CAPTURE_ALSA_DEVICE_INFO;


int _FindPCISlotName(const char *upath, char *name);
bool _RefreshAudioDevices2();
bool RefreshAudioDevices();
int GetAudioDevicesCount();
void GetAudioHwNameByindex(int nIndex, char *szHwName);
void GetAudioPaNameByindex(int nIndex, char *szPaName);
#endif // ALSADEVICEINFO_H
