#ifndef COMMON_H
#define COMMON_H

#include <regex.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <pwd.h>

static bool MatchReg(char *szString, const char *szPattern)
{
    regex_t reg;
    regmatch_t pm[10];
    const size_t nMatch = 10;

    int status = regcomp(&reg, szPattern, REG_NEWLINE | REG_EXTENDED);
    if (status != 0)
    {
        char szError[256];
        int nError = 256;

        nError = regerror(status, &reg, szError, nError);
        return false;
    }

    status = regexec(&reg, szString, nMatch, pm, 0);
    if (status == REG_NOMATCH)
    {
        regfree(&reg);
        char szError[256];
        int nError = 256;

        nError = regerror(status, &reg, szError, nError);
        return false;
    }

    regfree(&reg);
    return true;
}

/*
static bool CheckWriteAuthority(char *szPath)
{
    if(szPath == NULL)
        return false;

    struct stat buf;
    if (stat(szPath, &buf) != 0)
        return false;

    if (buf.st_uid == getuid())
    {
        if (buf.st_mode & S_IWUSR)
            return true;
    }
    else if (buf.st_gid == getgid())
    {
        if (buf.st_mode & S_IWGRP)
            return true;
    }
    else
    {
        if (buf.st_mode & S_IWOTH)
            return true;
    }

    return false;
}*/

/*static  bool IsAlphaNumeric(char *str)
{
    if (str == NULL)
        return false;

    char *temp = str;

    while(*temp)
    {
        if ( *str >= '0' && *str <= '9')
            return true;

        temp++;
    }

    return false;
}*/

#endif // COMMON_H
