#include "coptions.h"
#include "cffmpegencode.h"
#include "ccapturethread.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <stdint.h>
#include <math.h>
using namespace std;

int main(int argc, char **argv)
{
    //Get Cmd options
    COptions CmdOption;
    OPTIONS options = {0};
    OPTION_RESULT opr = CmdOption.ParseCommondLine(argc, argv);
    if(opr == OPTION_FAILED)
        return 0;
    else
        options = CmdOption.GetOptions();

    //init capture
    CCaptureThread capture;
    bool bRet = capture.InitCapture(options.szDevicePath, options.dwWidth, options.dwHeight);
    if(bRet == false)
    {
        capture.ExitCapture();
        return 0;
    }

    //init ffmpeg
    CFFmpegEncode encode;
    /*bool*/ bRet = encode.InitFFmpeg(options);
    if(bRet == false)
        return 0;

    bRet = capture.Create(options.dwWidth, options.dwHeight, options.dwFPS, &encode);
    if(bRet == false)
    {
        capture.ExitCapture();
        return 0;
    }

    capture.CheckKey();

    capture.Destory();
    capture.ExitCapture();
    encode.CloseFFmpeg();

    return 0;
}

