#include "widget.h"
#include "ui_widget.h"
#include <QVBoxLayout>

Widget::Widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Widget)
{
    MWCapture::Init();
    MWCapture::RefreshDevices();

    ui->setupUi(this);
    setWindowTitle(tr("Low-Latency"));
    setFixedSize(1225,670);

    m_grpNormal = new CGroupBox;
    m_grpNormal->setPicture(tr(":/image/lowlatency.bmp"));
    m_grpNormal->setTitle(tr("Normal Mode"));
    m_grpNormal->enableLowLatency(FALSE);

    m_grpLowLatency = new CGroupBox;
    m_grpLowLatency->setPicture(tr(":/image/lowlatency2.bmp"));
    m_grpLowLatency->setTitle(tr("Low-latency Mode"));
    m_grpLowLatency->enableLowLatency(TRUE);


    QVBoxLayout *mainLayout = new QVBoxLayout;
    mainLayout->addWidget(m_grpNormal);
    mainLayout->addWidget(m_grpLowLatency);

    setLayout(mainLayout);
}

Widget::~Widget()
{
    delete ui;
    delete m_grpNormal;
    delete m_grpLowLatency;

    MWCapture::Exit();
}
