#include "mainview.h"

CMainView::CMainView(QWidget *parent) : QWidget(parent)
{
    setUpdatesEnabled(false);

    m_mwCapture = new MWCapture;
    m_xcbRender = new VideoRenderXCB;
    m_xcbRender->Init(0,0,this->winId());

    m_timerFPSInfo = new QTimer;
    connect(m_timerFPSInfo,SIGNAL(timeout()),this,SLOT(updateFPSInfo()));
}


CMainView::~CMainView()
{
    delete m_mwCapture;
    m_mwCapture = NULL;
    delete m_xcbRender;
    m_xcbRender = NULL;
}


//Callback
void CMainView::VideoCaptureCallback(MWCAP_PTR pbImage, DWORD cbImage, void *pvParam)
{
    QMutexLocker lock(&m_lock);
    if(m_xcbRender != NULL)
        m_xcbRender->DisplayFrame((void *)(unsigned long)pbImage, cbImage);
    return;
}


void CMainView::VideoSignalChangedCallback()
{
    return;
}


void CMainView::updateFPSInfo()
{
    double dFPS = 0.0;
    dFPS = m_mwCapture->GetCurrentFPS();
    dFPS = (int)(dFPS*100);
    dFPS = dFPS/100;
    QString strFPS = QString("%1 FPS").arg(dFPS);
    emit sigSendFPS(strFPS);
}
