#ifndef COMMON_H
#define COMMON_H

#include <regex.h>
#include <sys/types.h>

static bool MatchReg(char *szString, const char *szPattern)
{
    regex_t reg;
    regmatch_t pm[10];
    const size_t nMatch = 10;

    int status = regcomp(&reg, szPattern, REG_NEWLINE | REG_EXTENDED);
    if (status != 0)
    {
        char szError[256];
        int nError = 256;

        nError = regerror(status, &reg, szError, nError);
        return false;
    }

    status = regexec(&reg, szString, nMatch, pm, 0);
    if (status == REG_NOMATCH)
    {
        regfree(&reg);
        char szError[256];
        int nError = 256;

        nError = regerror(status, &reg, szError, nError);
        return false;
    }

    regfree(&reg);
    return true;
}


/*static  bool IsAlphaNumeric(char *str)
{
    if (str == NULL)
        return false;

    char *temp = str;

    while(*temp)
    {
        if ( *str >= '0' && *str <= '9')
            return true;

        temp++;
    }

    return false;
}*/

#endif // COMMON_H
