#ifndef CAPTUREEXPRESS_H
#define CAPTUREEXPRESS_H

#include "publicheader.h"
#include <QMainWindow>
#include <QMainWindow>
#include <QComboBox>
#include <QPushButton>
#include <QLabel>
#include <QLayout>
#include <QWidget>
#include <QStatusBar>
#include <QMenuBar>
#include <QApplication>
#include <QDesktopWidget>
#include <QIcon>
#include <QStringList>
#include <QMessageBox>
#include <QDateTime>
#include <QDesktopServices>
#include <QFontMetrics>
#include <QFont>
#include <QDir>
#include <QFileDialog>
#include "jpeglib.h"
#include <QKeyEvent>
class CVideoRender;
class CCaptureThread;
class CVideoWidget;


class CCaptureExpress : public QMainWindow,public ICaptureCallback
{
    Q_OBJECT



public:
    CCaptureExpress(QWidget *parent = 0);
    ~CCaptureExpress();

    void CreateWindow(char* argv);
    bool CaptureThread();
    //void OnCaptureCallback(VideoRenderImageBuf *pBuffer);
    void OnCaptureCallback(MWCAP_PTR buffer, size_t size);
    void OnSnapshotCallback(unsigned char *pImage);

protected:

    int SetCombox();
    void GetStatus();

    //events
    void closeEvent(QCloseEvent *event);
    void timerEvent(QTimerEvent *event);

    //handle status string
    QString GetElidedText(QFont font, QString strEdit, int nMaxWidth);


protected:
    //widget
    QPushButton     *m_btnFullScreen;
    QPushButton     *m_btnSnapshot;
    QLabel          *m_labVideoChannel;
    QLabel          *m_labFrameRate;
    QLabel          *m_labVideoResolution;
    QComboBox       *m_cmbVideoChannel;
    QComboBox       *m_cmbFrameRate;
    QComboBox       *m_cmbVideoResolution;
    QStatusBar      *m_barStatus;
    QLabel          *m_labStatus;

    CVideoWidget    *m_wndVideo;

    //thread
    CCaptureThread      *m_CaptureThread;
    int                 m_nChannelNum;
    double              m_dFrameRate;

    //status
    bool                m_bCaptureVideo;
    bool                m_bSnapshot;
    QString             m_strStatus;
    QStringList         m_lstChannelName;

    QString             m_strShotImageName;
    int                 m_TimerID;

    //argv arguments status
    bool                m_bNoDisplay;
signals:

public slots:
    void onClickedActionExit(bool bFlag);
    void onClickedActionAbout(bool bFlag);
    void onClickedBtnSnapshot(bool bFlag);
    void onClickedBtnOpenSnapshot(bool bFlag);
    void onChangedChannelIndex(int index);
    void onChangedResolutionIndex(int index);
    void onChangedFrameRateIndex(int index);
    void SetRefreshBackground(bool bFlag);
    void OpenSnapshotURL(QString strImagePath);

};

#endif // CAPTUREEXPRESS_H
