#ifndef CCAPTURETHREAD_H
#define CCAPTURETHREAD_H

#include <QObject>
#include <QDebug>
#include <pthread.h>
#include <QDateTime>
#include "publicheader.h"
class CCaptureThread : public QObject
{
    Q_OBJECT
public:
    explicit CCaptureThread(QObject *parent = 0);
    ~CCaptureThread();

    void StartThread(int nIndex, int cx, int cy, double dFrameDuration, ICaptureCallback *pCallback, VideoRenderImageBuf *pBuffer);
    bool StopThread();

    bool StartSnapShotThread();
    void StopSnapShotThread();

    void GetInputSignal(StatusRet *pStatus);
    double GetFPS();
    void SetCaptureFourcc(DWORD dwFourcc)
    {
        m_dwfourcc = dwFourcc;
        //m_dwfourcc = MWFOURCC_YUY2;
    }

private:
    static void * Create(void *pvParam)
    {
        CCaptureThread *pThis = (CCaptureThread *)pvParam;
        pThis->CreateThread();
    }

     void CreateThread();

     static void * CreateSnapShotThread(void *pvParam)
     {
         CCaptureThread *pThis = (CCaptureThread *)pvParam;
         pThis->SnapShotThreadProc();
     }

     void SnapShotThreadProc();

protected:

    int         m_cx;
    int         m_cy;
    int         m_nIndex;
    HCHANNEL    m_hChannel;
    HCHANNEL    m_hSnapshotChannel;
    DWORD       m_dwfourcc;
    bool                            m_bStartCapture;
    double                          m_dFrameDuration;
    double                          m_dFPS;
    ICaptureCallback                *m_pCallback;
    VideoRenderImageBuf             *m_pImageBuffer;
    pthread_t                       m_pid;
    pthread_t                       m_nSnapshotpid;
    MWCAP_VIDEO_SIGNAL_STATUS       m_videoSignalStatus;
    MWCAP_AUDIO_SIGNAL_STATUS       m_audioSignalStatus;

public slots:
};

#endif // CCAPTURETHREAD_H
