#include "videowidget.h"
#include <QHBoxLayout>
#include "captureexpress.h"

CVideoWidget::CVideoWidget(QWidget *parent) : QWidget(parent)
{
    m_dwFourcc = MWFOURCC_YUY2;
    m_VideoRender = NULL;
    //CreateLayout();
    //CreateRender();
}

CVideoWidget::~CVideoWidget()
{
    delete m_wndSubWidget;
}

bool CVideoWidget::CreateRender()
{
    do
    {
        m_VideoRender = new VideoRenderXCB;
        bool bRes = m_VideoRender->Init(1920, 1080, m_wndSubWidget->winId());
        if(bRes != true)
            break;

        bRes = SupportFourcc(&m_dwFourcc);
        if(bRes == false)
            break;

        bRes = m_VideoRender->SetFrameFormat(1920, 1080, m_dwFourcc, false);
        if(bRes != true)
            break;

        m_pVideoBuffer = m_VideoRender->AllocImageBuffer(VIDEO_RENDER_IMAGEBUF_VIRTUAL);

        return true;

    }while(false);

    return false;
}

void CVideoWidget::DestoryRender()
{
    m_VideoRender->FreeImageBuffer(m_pVideoBuffer);
    delete m_VideoRender;
}

void CVideoWidget::ResetBuffer(int nWidth, int nHeight)
{
//    m_VideoRender->FreeImageBuffer(m_pVideoBuffer);
    bool bRes = m_VideoRender->SetFrameFormat(nWidth, nHeight, m_dwFourcc, false);

//    m_pVideoBuffer = m_VideoRender->AllocImageBuffer(VIDEO_RENDER_IMAGEBUF_VIRTUAL);
}

//void CVideoWidget::DisplayFrame(VideoRenderImageBuf *pVideouffer)
//{
//    m_VideoRender->DisplayFrame(pVideouffer);
//}

void CVideoWidget::DisplayFrame(void *buffer, size_t size)
{
    if(m_VideoRender != NULL)
        m_VideoRender->DisplayFrame(buffer, size);
}

//protect:
void CVideoWidget::CreateLayout()
{
    m_wndSubWidget = new QWidget(this);

    QHBoxLayout *pSubLayout = new QHBoxLayout;
    pSubLayout->addWidget(m_wndSubWidget);
    this->setLayout(pSubLayout);
    pSubLayout->setContentsMargins(0, 0, 0, 0);
}

bool CVideoWidget::SupportFourcc(unsigned int *dwFourcc)
{
    int nCount = 0;
    uint32_t *pFourcc;
    pFourcc = m_VideoRender->GetSupportedFourcc(nCount);

    if (nCount <= 0)
        return false;
    else
    {
        *dwFourcc = *(pFourcc + 0);
        return true;
    }
}
