#include "Ctabproperty.h"
#include "Cdlgampproc.h"
#include "cdlghdimi.h"
#include "cdlginfo.h"
#include "cdlginput.h"
#include "cdlgosd.h"
#include "cdlgtiming.h"
#include "cdlgvideo.h"

CTabProperty::CTabProperty(QWidget *parent) : QWidget(parent)
{
    QHBoxLayout *lay = new QHBoxLayout;
    lay->setContentsMargins(0, 0, 0, 0);
    this->setLayout(lay);

    m_tabMain = new QTabWidget(this);
    m_tabMain->setFocusPolicy(Qt::NoFocus);
    lay->addWidget(m_tabMain);

    m_dlgTiming = new CDlgTiming(m_tabMain);
    m_tabMain->addTab(m_dlgTiming, "Timing");

    m_dlgOSD = new CDlgOSD(m_tabMain);
    m_tabMain->addTab(m_dlgOSD, "OSD");

    m_dlgHDMI = new CDlgHDIMI(m_tabMain);
    m_tabMain->addTab(m_dlgHDMI, "HDMI");


    m_dlgVideo = new CDlgVideo(m_tabMain);
    m_tabMain->addTab(m_dlgVideo, "Video");

    m_dlgInput = new CDlgInput(m_tabMain);
    m_tabMain->addTab(m_dlgInput, "Input");


    m_dlgInfo = new CDlgInfo(m_tabMain);
    m_tabMain->addTab(m_dlgInfo, "Info");

    m_dlgAmpProc = new CDlgAmpproc(m_tabMain);
    m_tabMain->addTab(m_dlgAmpProc, "Amp Proc");

}

void CTabProperty::VideoDeviceChanged()
{
    m_dlgInfo->UpdateInfoTable();
    m_dlgHDMI->UpdateHDMI();
    m_dlgInput->UpdateInput();
    m_dlgVideo->UpdateVideo();
    m_dlgOSD->UpdateOSD();
    m_dlgTiming->UpdateTiming();
}
