#ifndef CDLGINPUT_H
#define CDLGINPUT_H

#include <QWidget>
#include "publicheaders.h"
#include "cvideochannel.h"
#include "isignalnotify.h"
#include "mgcommon.h"
#include "cgenerateshfile.h"

class CDlgInput : public QWidget, public ISignalNotify
{
    Q_OBJECT
public:
    explicit CDlgInput(QWidget *parent = 0);

    void UpdateInput();

    //ISignalNotify
    virtual void onInputStatuChanged(unsigned long long ullStatusBits);
    virtual void onInputSourceChanged(unsigned long long ullStatusBits);

private:
    void UpdateVideoStatus();
    void UpdateAudioStatus();
    void UpdateSpecificStatus();
    void InputSourceChange();
    void SetAVInputType();

    int GetInputTypeIndex(int nValue, int nMin, int nMax);
    void GetVideoType( MWCAP_VIDEO_INPUT_TYPE& videoInputType, char* pszType, int nTypeValue, int& nIndex );
    void GetAudioType( MWCAP_AUDIO_INPUT_TYPE& audioInputType, char* pszType, int nTypeValue, int& nIndex );
    void AddItem(QList<TABLE_ITEM> &lstTableItems, QString key, QString strValue);

protected:
    QComboBox       *m_cmbVideoInput;
    QComboBox       *m_cmbAudioInput;

    QCheckBox       *m_ckbAutoScan;
    QCheckBox       *m_ckbLinkAv;

    QTableWidget    *m_tableVideoStatus;
    QTableWidget    *m_tableAudioStatus;
    QTableWidget    *m_tableSpecificStatus;

    CGenerateSHFile *m_shFile;

signals:
    void sigInputStatuChanged(unsigned long long);
    void sigInputSourceChanged(unsigned long long);

public slots:
    void onVideoInputChanged(int nIndex);
    void onAudioInputChanged(int nIndex);
    void onAutoScanChecked(int nStatus);
    void onLinkAVChecked(int nStatus);

    void onInputStatuChangedMain(unsigned long long ullStatusBits);
    void onInputSourceChangedMain(unsigned long long ullStatusBits);


};

#endif // CDLGINPUT_H
