#include "cdlgvideo.h"

CDlgVideo::CDlgVideo(QWidget *parent) : QWidget(parent)
{
    int i = 0;
    int count = MWGetChannelCount();
    char path[256];
    for(i = 0; i < count; i++)
    {
        MWGetDevicePath(i, path);
        HANDLE64 hChannel = MWOpenChannelByPath(path);
        MWGetVideoProcessSettings(hChannel, &m_videoSettings[i]);
        m_bAspectDefault[i] = false;
        m_bColorfmtDefault[i] = false;
        m_bQuantDefault[i] = false;
    }

    //input
    m_gpboxInput = new QGroupBox("input", this);
    m_ckbInputAspect = new QCheckBox("Aspect ratio:", this);
    m_ckbInputColorFmt = new QCheckBox("Color format:", this);
    m_ckbInputQuant = new QCheckBox("Quantization:", this);
    m_ckbInputAspect->setChecked(false);
    m_ckbInputColorFmt->setChecked(false);
    m_ckbInputQuant->setChecked(false);

    m_ckbInputAspect->setFocusPolicy(Qt::NoFocus);
    m_ckbInputColorFmt->setFocusPolicy(Qt::NoFocus);
    m_ckbInputQuant->setFocusPolicy(Qt::NoFocus);

    m_spinInputAspectX = new QSpinBox(this);
    m_spinInputAspectY = new QSpinBox(this);
    m_spinInputAspectX->setRange(1, 2048);
    m_spinInputAspectY->setRange(1, 2048);
    QLabel *plblColon = new QLabel(":",this);

    m_cmbInputColorFmt = new QComboBox(this);
    m_cmbInputQuant = new QComboBox(this);

    QHBoxLayout *pHLayoutInputAspect = new QHBoxLayout;
    pHLayoutInputAspect->addWidget(m_spinInputAspectX);
    pHLayoutInputAspect->addWidget(plblColon);
    pHLayoutInputAspect->addWidget(m_spinInputAspectY);

    QGridLayout *pgLayoutInput = new QGridLayout;
    int num = 0;
    pgLayoutInput->addWidget(m_ckbInputAspect, num, 0, 1, 2);
    pgLayoutInput->addLayout(pHLayoutInputAspect, num, 2, 1, 1);

    ++ num;
    pgLayoutInput->addWidget(m_ckbInputColorFmt, num, 0, 1, 2);
    pgLayoutInput->addWidget(m_cmbInputColorFmt, num, 2, 1, 4);

    ++ num;
    pgLayoutInput->addWidget(m_ckbInputQuant, num, 0, 1, 2);
    pgLayoutInput->addWidget(m_cmbInputQuant, num, 2, 1, 4);

    m_gpboxInput->setLayout(pgLayoutInput);

    //output
    m_gpboxOutput = new QGroupBox("Output", this);

    m_ckbOutputAspect = new QCheckBox("Aspect ratio:",this);
    m_ckbOutputCrop = new QCheckBox("Crop input:",this);
    m_ckbOutputColorFmt = new QCheckBox("Color format:",this);
    m_ckbOutputQuant = new QCheckBox("Quantization:",this);
    m_ckbOutputSaturation = new QCheckBox("Saturation:",this);
    m_ckbOutputLowlatency = new QCheckBox("Low latency mode", this);

    m_spinOutputAspectX = new QSpinBox(this);
    m_spinOutputAspectY = new QSpinBox(this);
    m_spinOutputCropLeft = new QSpinBox(this);
    m_spinOutputCropRight = new QSpinBox(this);
    m_spinOutputCropTop = new QSpinBox(this);
    m_spinOutputCropBottom = new QSpinBox(this);

    m_cmbOutputColorFmt = new QComboBox(this);
    m_cmbOutputQuant = new QComboBox(this);
    m_cmbOutputSaturation = new QComboBox(this);
    m_cmbOutputDeint = new QComboBox(this);
    m_cmbOutputAR = new QComboBox(this);

    m_btnLoadPresent = new QPushButton("Load present");
    m_btnSavePresent = new QPushButton("Save present");

    QLabel *plblComma1 = new QLabel(":", this);
    QLabel *plblComma2 = new QLabel(",", this);
    QLabel *plblComma3 = new QLabel(",", this);
    QLabel *plblComma4 = new QLabel("-", this);
    QLabel *plblDeint = new QLabel("Deinterlace", this);
    QLabel *plblAR = new QLabel("AR convertion", this);

    m_ckbOutputAspect->setFocusPolicy(Qt::NoFocus);
    m_ckbOutputColorFmt->setFocusPolicy(Qt::NoFocus);
    m_ckbOutputCrop->setFocusPolicy(Qt::NoFocus);
    m_ckbOutputLowlatency->setFocusPolicy(Qt::NoFocus);
    m_ckbOutputQuant->setFocusPolicy(Qt::NoFocus);
    m_ckbOutputSaturation->setFocusPolicy(Qt::NoFocus);

    QHBoxLayout *pHLayoutOutputAspect = new QHBoxLayout;
    pHLayoutOutputAspect->addWidget(m_spinOutputAspectX);
    pHLayoutOutputAspect->addWidget(plblComma1);
    pHLayoutOutputAspect->addWidget(m_spinOutputAspectY);
    pHLayoutOutputAspect->addStretch();

    pHLayoutOutputAspect->addWidget(m_ckbOutputLowlatency);

    QHBoxLayout *pHLayoutOutputCropLeft = new QHBoxLayout;
    pHLayoutOutputCropLeft->addWidget(m_spinOutputCropLeft);
    pHLayoutOutputCropLeft->addWidget(plblComma2);
    pHLayoutOutputCropLeft->addWidget(m_spinOutputCropTop);
    pHLayoutOutputCropLeft->addStretch();
    pHLayoutOutputCropLeft->addWidget(plblComma4);
    pHLayoutOutputCropLeft->addStretch();
    pHLayoutOutputCropLeft->addWidget(m_spinOutputCropRight);
    pHLayoutOutputCropLeft->addWidget(plblComma3);
    pHLayoutOutputCropLeft->addWidget(m_spinOutputCropBottom);

    QGridLayout *pgLayoutOutput = new QGridLayout;
    num = 0;
    pgLayoutOutput->addWidget(m_ckbOutputAspect, num, 0, 1, 2);
    pgLayoutOutput->addLayout(pHLayoutOutputAspect, num, 2, 1, 4);

    ++ num;
    pgLayoutOutput->addWidget(m_ckbOutputCrop, num, 0, 1, 2);
    pgLayoutOutput->addLayout(pHLayoutOutputCropLeft, num, 2, 1, 4);

    ++ num;
    pgLayoutOutput->addWidget(m_ckbOutputColorFmt, num, 0, 1, 2);
    pgLayoutOutput->addWidget(m_cmbOutputColorFmt, num, 2, 1, 4);

    ++ num;
    pgLayoutOutput->addWidget(m_ckbOutputQuant, num, 0, 1, 2);
    pgLayoutOutput->addWidget(m_cmbOutputQuant, num, 2, 1, 4);

    ++ num;
    pgLayoutOutput->addWidget(m_ckbOutputSaturation, num, 0, 1, 2);
    pgLayoutOutput->addWidget(m_cmbOutputSaturation, num, 2, 1, 4);

    ++ num;
    pgLayoutOutput->addWidget(plblDeint, num, 0, 1, 2);
    pgLayoutOutput->addWidget(m_cmbOutputDeint, num, 2, 1, 4);

    ++ num;
    pgLayoutOutput->addWidget(plblAR, num, 0, 1, 2);
    pgLayoutOutput->addWidget(m_cmbOutputAR, num, 2, 1, 4);

    QHBoxLayout *pHLayoutOutputPresent = new QHBoxLayout;
    pHLayoutOutputPresent->addStretch();
    pHLayoutOutputPresent->addWidget(m_btnLoadPresent);
    pHLayoutOutputPresent->addWidget(m_btnSavePresent);

    QVBoxLayout *pVLayoutOutput = new QVBoxLayout;
    pVLayoutOutput->addLayout(pgLayoutOutput);
    pVLayoutOutput->addLayout(pHLayoutOutputPresent);

    m_gpboxOutput->setLayout(pVLayoutOutput);

    QVBoxLayout *pVLayoutMain = new QVBoxLayout;
    pVLayoutMain->addWidget(m_gpboxInput);
    pVLayoutMain->addWidget(m_gpboxOutput);
    pVLayoutMain->addStretch();

    this->setLayout(pVLayoutMain);

    m_cmbInputColorFmt->addItem("RGB");
    m_cmbInputColorFmt->addItem("YUV BT.601");
    m_cmbInputColorFmt->addItem("YUV BT.709");
    m_cmbInputColorFmt->addItem("YUV BT.2020");

    m_cmbInputQuant->addItem("Full range");
    m_cmbInputQuant->addItem("Limited range");

    m_cmbOutputColorFmt->addItem("RGB");
    m_cmbOutputColorFmt->addItem("YUV BT.601");
    m_cmbOutputColorFmt->addItem("YUV BT.709");
    m_cmbOutputColorFmt->addItem("YUV BT.2020");

    m_cmbOutputQuant->addItem("Full range");
    m_cmbOutputQuant->addItem("Limited range");

    m_cmbOutputSaturation->addItem("Full range");
    m_cmbOutputSaturation->addItem("Limited range");
    m_cmbOutputSaturation->addItem("Extended gamut");

    m_cmbOutputDeint->addItem("Weave");
    m_cmbOutputDeint->addItem("Blend");
    m_cmbOutputDeint->addItem("Top field");
    m_cmbOutputDeint->addItem("Bottom field");

    m_cmbOutputAR->addItem("Ignore");
    m_cmbOutputAR->addItem("Cropping");
    m_cmbOutputAR->addItem("Padding");

    m_spinOutputAspectX->setRange(1, 2048);
    m_spinOutputAspectY->setRange(1, 2048);

    m_spinOutputCropLeft->setRange(0, 4096);
    m_spinOutputCropTop->setRange(0, 4096);
    m_spinOutputCropRight->setRange(0, 4096);
    m_spinOutputCropBottom->setRange(0, 4096);

    g_capture.AddNotify(this);
    m_shFile = new CGenerateSHFile(this);

    UpdateVideo();

    QApplication::connect(m_btnLoadPresent, SIGNAL(clicked(bool)), this, SLOT(onLoadPresetClicked(bool)));
    QApplication::connect(m_btnSavePresent, SIGNAL(clicked(bool)), this, SLOT(onSavePresetClicked(bool)));
    QApplication::connect(this, SIGNAL(sigInputSourceChanged(unsigned long long)), this, SLOT(onInputSourceChangedMain(unsigned long long)));
}

void CDlgVideo::UpdateVideo()
{
    UpdateVideoSettings();
}

void CDlgVideo::UpdateVideoSettings()
{
    QApplication::disconnect(m_ckbInputAspect, SIGNAL(stateChanged(int)), this, SLOT(onInputAspectChecked(int )));
    QApplication::disconnect(m_ckbInputColorFmt, SIGNAL(stateChanged(int)), this, SLOT(onInputColorFormatChecked(int )));
    QApplication::disconnect(m_ckbInputQuant, SIGNAL(stateChanged(int)), this, SLOT(onInputQuantChecked(int )));

    QApplication::disconnect(m_spinInputAspectX, SIGNAL(valueChanged(int)), this, SLOT(onInputAspectXValueChanged(int )));
    QApplication::disconnect(m_spinInputAspectY, SIGNAL(valueChanged(int)), this, SLOT(onInputAspectYValueChanged(int )));

    QApplication::disconnect(m_cmbInputColorFmt, SIGNAL(currentIndexChanged(int )), this, SLOT(onInputColorFormatIndexChanged(int )));
    QApplication::disconnect(m_cmbInputQuant, SIGNAL(currentIndexChanged(int )), this, SLOT(onInputQuantIndexChanged(int )));

    QApplication::disconnect(m_ckbInputAspect, SIGNAL(stateChanged(int)), this, SLOT(onOutputAspectChecked(int )));
    QApplication::disconnect(m_ckbOutputLowlatency, SIGNAL(stateChanged(int)), this, SLOT(onLowLatencyChecked(int )));
    QApplication::disconnect(m_ckbOutputCrop, SIGNAL(stateChanged(int)), this, SLOT(onOutputCropChecked(int )));
    QApplication::disconnect(m_ckbOutputColorFmt, SIGNAL(stateChanged(int)), this, SLOT(onOutputColorFormatChecked(int )));
    QApplication::disconnect(m_ckbOutputQuant, SIGNAL(stateChanged(int)), this, SLOT(onOutputQuantChecked(int )));
    QApplication::disconnect(m_ckbOutputSaturation, SIGNAL(stateChanged(int)), this, SLOT(onOutputSaturationChecked(int )));

    QApplication::disconnect(m_spinOutputAspectX, SIGNAL(valueChanged(int)), this, SLOT(onOutputAspectXValueChanged(int )));
    QApplication::disconnect(m_spinOutputAspectY, SIGNAL(valueChanged(int)), this, SLOT(onOutputAspectYValueChanged(int )));
    QApplication::disconnect(m_spinOutputCropLeft, SIGNAL(valueChanged(int)), this, SLOT(onOutputCropLeft(int )));
    QApplication::disconnect(m_spinOutputCropTop, SIGNAL(valueChanged(int)), this, SLOT(onOutputCropTop(int )));
    QApplication::disconnect(m_spinOutputCropRight, SIGNAL(valueChanged(int)), this, SLOT(onOutputCropRight(int )));
    QApplication::disconnect(m_spinOutputCropBottom, SIGNAL(valueChanged(int)), this, SLOT(onOutputCropBottom(int )));

    QApplication::disconnect(m_cmbOutputColorFmt, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutputColorFormatIndexChanged(int )));
    QApplication::disconnect(m_cmbOutputQuant, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutputQuantIndexChanged(int )));
    QApplication::disconnect(m_cmbOutputSaturation, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutSaturationIndexChanged(int )));
    QApplication::disconnect(m_cmbOutputDeint, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutputDeintIndexChanged(int )));
    QApplication::disconnect(m_cmbOutputAR, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutputARIndexChanged(int )));

    UpdateInputSettings();
    UpdateOutputSettings();

    QApplication::connect(m_ckbInputAspect, SIGNAL(stateChanged(int)), this, SLOT(onInputAspectChecked(int )));
    QApplication::connect(m_ckbInputColorFmt, SIGNAL(stateChanged(int)), this, SLOT(onInputColorFormatChecked(int )));
    QApplication::connect(m_ckbInputQuant, SIGNAL(stateChanged(int)), this, SLOT(onInputQuantChecked(int )));

    QApplication::connect(m_spinInputAspectX, SIGNAL(valueChanged(int)), this, SLOT(onInputAspectXValueChanged(int )));
    QApplication::connect(m_spinInputAspectY, SIGNAL(valueChanged(int)), this, SLOT(onInputAspectYValueChanged(int )));

    QApplication::connect(m_cmbInputColorFmt, SIGNAL(currentIndexChanged(int )), this, SLOT(onInputColorFormatIndexChanged(int )));
    QApplication::connect(m_cmbInputQuant, SIGNAL(currentIndexChanged(int )), this, SLOT(onInputQuantIndexChanged(int )));

    QApplication::connect(m_ckbOutputAspect, SIGNAL(stateChanged(int)), this, SLOT(onOutputAspectChecked(int )));
    QApplication::connect(m_ckbOutputLowlatency, SIGNAL(stateChanged(int)), this, SLOT(onLowLatencyChecked(int )));
    QApplication::connect(m_ckbOutputCrop, SIGNAL(stateChanged(int)), this, SLOT(onOutputCropChecked(int )));
    QApplication::connect(m_ckbOutputColorFmt, SIGNAL(stateChanged(int)), this, SLOT(onOutputColorFormatChecked(int )));
    QApplication::connect(m_ckbOutputQuant, SIGNAL(stateChanged(int)), this, SLOT(onOutputQuantChecked(int )));
    QApplication::connect(m_ckbOutputSaturation, SIGNAL(stateChanged(int)), this, SLOT(onOutputSaturationChecked(int )));

    QApplication::connect(m_spinOutputAspectX, SIGNAL(valueChanged(int)), this, SLOT(onOutputAspectXValueChanged(int )));
    QApplication::connect(m_spinOutputAspectY, SIGNAL(valueChanged(int)), this, SLOT(onOutputAspectYValueChanged(int )));
    QApplication::connect(m_spinOutputCropLeft, SIGNAL(valueChanged(int)), this, SLOT(onOutputCropLeft(int )));
    QApplication::connect(m_spinOutputCropTop, SIGNAL(valueChanged(int)), this, SLOT(onOutputCropTop(int )));
    QApplication::connect(m_spinOutputCropRight, SIGNAL(valueChanged(int)), this, SLOT(onOutputCropRight(int )));
    QApplication::connect(m_spinOutputCropBottom, SIGNAL(valueChanged(int)), this, SLOT(onOutputCropBottom(int )));

    QApplication::connect(m_cmbOutputColorFmt, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutputColorFormatIndexChanged(int )));
    QApplication::connect(m_cmbOutputQuant, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutputQuantIndexChanged(int )));
    QApplication::connect(m_cmbOutputSaturation, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutSaturationIndexChanged(int )));
    QApplication::connect(m_cmbOutputDeint, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutputDeintIndexChanged(int )));
    QApplication::connect(m_cmbOutputAR, SIGNAL(currentIndexChanged(int )), this, SLOT(onOutputARIndexChanged(int )));
}

void CDlgVideo::UpdateInputSettings()
{
    int nIndex = g_capture.GetCurrentDeviceIndex();

    MWCAP_VIDEO_SIGNAL_STATUS videoSignalStatus;
    MW_RESULT nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoSignalStatus);

    QString strSignal = "";
    if (videoSignalStatus.state == MWCAP_VIDEO_SIGNAL_NONE)
        strSignal = "Input - (No Signal)";
    else
        strSignal = QString("Input - (%1x%2%3)").arg(videoSignalStatus.cx).arg(videoSignalStatus.cy).arg(videoSignalStatus.bInterlaced ? "i" : "p");
    m_gpboxInput->setTitle(strSignal);

    bool bCheck = true;
    int nAspectX = 0, nAspectY = 0;
    nRet = MWGetVideoInputAspectRatio(g_capture.GetVideoHandle(), &nAspectX, &nAspectY);
    if (nAspectX == 0 && nAspectY == 0)
    {
        bCheck = false;
        if(videoSignalStatus.state != MWCAP_VIDEO_SIGNAL_LOCKED)
        {
            nAspectX = 16;
            nAspectY = 9;
        }
        else
        {
            nAspectX = videoSignalStatus.nAspectX;
            nAspectY = videoSignalStatus.nAspectY;
        }
    }

    if(m_bAspectDefault[nIndex] == false)
        bCheck = false;

    m_ckbInputAspect->setChecked(bCheck);
    m_spinInputAspectX->setValue(nAspectX);
    m_spinInputAspectY->setValue(nAspectY);
    m_spinInputAspectX->setRange(1, 2048);
    m_spinInputAspectY->setRange(1, 2048);
    m_spinInputAspectX->setEnabled(bCheck);
    m_spinInputAspectY->setEnabled(bCheck);

    MWCAP_VIDEO_COLOR_FORMAT colorFormat;
    nRet = MWGetVideoInputColorFormat(g_capture.GetVideoHandle(), &colorFormat);
    bCheck = true;
    int nSel = 0;
    switch (colorFormat)
    {
    case MWCAP_VIDEO_COLOR_FORMAT_UNKNOWN:
        bCheck = false;
        switch (videoSignalStatus.colorFormat)
        {
        case MWCAP_VIDEO_COLOR_FORMAT_RGB:
            nSel = 0;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV601:
            nSel = 1;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV709:
            nSel = 2;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV2020:
            nSel = 3;
            break;
        default:
            break;
        }
        break;
    case MWCAP_VIDEO_COLOR_FORMAT_RGB:
        nSel = 0;
        break;
    case MWCAP_VIDEO_COLOR_FORMAT_YUV601:
        nSel = 1;
        break;
    case MWCAP_VIDEO_COLOR_FORMAT_YUV709:
        nSel = 2;
        break;
    case MWCAP_VIDEO_COLOR_FORMAT_YUV2020:
        nSel = 3;
        break;
    default:
        break;
    }

    if(m_bColorfmtDefault[nIndex] == false)
        bCheck = false;

    m_ckbInputColorFmt->setChecked(bCheck);
    m_cmbInputColorFmt->setCurrentIndex(nSel);
    m_cmbInputColorFmt->setEnabled(bCheck);

    MWCAP_VIDEO_QUANTIZATION_RANGE quantRange;
    nRet = MWGetVideoInputQuantizationRange(g_capture.GetVideoHandle(), &quantRange);

    bCheck = true;
    nSel = 0;
    switch (quantRange)
    {
    case MWCAP_VIDEO_QUANTIZATION_UNKNOWN:
        bCheck = false;
        switch(videoSignalStatus.quantRange)
        {
        case MWCAP_VIDEO_QUANTIZATION_FULL:
            nSel = 0;
            break;
        case MWCAP_VIDEO_QUANTIZATION_LIMITED:
            nSel = 1;
            break;
        default:
            break;
        }
        break;
    case MWCAP_VIDEO_QUANTIZATION_FULL:
        nSel = 0;
        break;
    case MWCAP_VIDEO_QUANTIZATION_LIMITED:
        nSel = 1;
        break;
    default:
        break;
    }

    if(m_bQuantDefault[nIndex] == false)
        bCheck = false;

    m_ckbInputQuant->setChecked(bCheck);
    m_cmbInputQuant->setCurrentIndex(nSel);
    m_cmbInputQuant->setEnabled(bCheck);
}

void CDlgVideo::UpdateOutputSettings()
{
    MW_RESULT nRet;
    MWCAP_VIDEO_PROCESS_SETTINGS videoProcessSettings;
    MWCAP_VIDEO_SIGNAL_STATUS videoSignalStatus;
    nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoProcessSettings);
    nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoSignalStatus);

    bool bChecked = true;
    int nAspectX = 0, nAspectY = 0;
    if (videoProcessSettings.nAspectX == 0 && videoProcessSettings.nAspectY == 0)
    {
        bChecked = false;
        if (videoSignalStatus.state == MWCAP_VIDEO_SIGNAL_LOCKED) {
            nAspectX = videoSignalStatus.nAspectX;
            nAspectY = videoSignalStatus.nAspectY;
        }
        else
        {
            nAspectX = 16;
            nAspectY = 9;
        }
    }
    else
    {
        nAspectX = videoProcessSettings.nAspectX;
        nAspectY = videoProcessSettings.nAspectY;
    }

    m_spinOutputAspectX->setValue(nAspectX);
    m_spinOutputAspectY->setValue(nAspectY);
    m_spinOutputAspectX->setEnabled(bChecked);
    m_spinOutputAspectY->setEnabled(bChecked);
    m_ckbOutputAspect->setChecked(bChecked);
    g_capture.SetVideoAspectY(nAspectX);
    g_capture.SetVideoAspectX(nAspectY);

    m_ckbOutputLowlatency->setChecked(videoProcessSettings.bLowLatency);
    g_capture.SetLowLatency(videoProcessSettings.bLowLatency);

    bChecked = true;
    RECT rect = videoProcessSettings.rectSource;
    if (rect.left == 0 && rect.top == 0 && rect.bottom == 0 && rect.right == 0) {
        bChecked = false;
        if (videoSignalStatus.state == MWCAP_VIDEO_SIGNAL_LOCKED) {
            rect.right = videoSignalStatus.cx;
            rect.bottom = videoSignalStatus.cy;

            m_spinOutputCropLeft->setRange(0, videoSignalStatus.cx);
            m_spinOutputCropTop->setRange(0, videoSignalStatus.cy);
            m_spinOutputCropRight->setRange(0, videoSignalStatus.cx);
            m_spinOutputCropBottom->setRange(0, videoSignalStatus.cy);
        }
    }

    m_ckbOutputCrop->setChecked(bChecked);
    m_spinOutputCropLeft->setValue(rect.left);
    m_spinOutputCropTop->setValue(rect.top);
    m_spinOutputCropRight->setValue(rect.right);
    m_spinOutputCropBottom->setValue(rect.bottom);

    m_spinOutputCropLeft->setEnabled(bChecked);
    m_spinOutputCropTop->setEnabled(bChecked);
    m_spinOutputCropRight->setEnabled(bChecked);
    m_spinOutputCropBottom->setEnabled(bChecked);
    g_capture.SetVideoCropRect(&rect);

    bChecked = true;
    int nSel = 0;
    switch (videoProcessSettings.colorFormat)
    {
    case MWCAP_VIDEO_COLOR_FORMAT_UNKNOWN:
        bChecked = false;
        switch (videoSignalStatus.colorFormat)
        {
        case MWCAP_VIDEO_COLOR_FORMAT_RGB:
            nSel = 0;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV601:
            nSel = 1;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV709:
            nSel = 2;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV2020:
            nSel = 3;
            break;
        }
        break;
    case MWCAP_VIDEO_COLOR_FORMAT_RGB:
        nSel = 0;
        break;
    case MWCAP_VIDEO_COLOR_FORMAT_YUV601:
        nSel = 1;
        break;
    case MWCAP_VIDEO_COLOR_FORMAT_YUV709:
        nSel = 2;
        break;
    case MWCAP_VIDEO_COLOR_FORMAT_YUV2020:
        nSel = 3;
        break;
    }
    m_ckbOutputColorFmt->setChecked(bChecked);
    m_cmbOutputColorFmt->setCurrentIndex(nSel);
    m_cmbOutputColorFmt->setEnabled(bChecked);
    if(videoProcessSettings.colorFormat == MWCAP_VIDEO_COLOR_FORMAT_UNKNOWN)
        g_capture.SetVideoColorFormat(videoSignalStatus.colorFormat);
    else
        g_capture.SetVideoColorFormat(videoProcessSettings.colorFormat);

    bChecked = true;
    nSel = 0;
    switch (videoProcessSettings.quantRange)
    {
    case MWCAP_VIDEO_QUANTIZATION_UNKNOWN:
        bChecked = false;
        switch (videoSignalStatus.quantRange)
        {
        case MWCAP_VIDEO_QUANTIZATION_FULL:
            nSel = 0;
            break;
        case MWCAP_VIDEO_QUANTIZATION_LIMITED:
            nSel = 1;
            break;
        }
        m_cmbOutputQuant->setCurrentIndex(nSel);
        break;
    case MWCAP_VIDEO_QUANTIZATION_FULL:
        nSel = 0;
        break;
    case MWCAP_VIDEO_QUANTIZATION_LIMITED:
        nSel = 1;
        break;
    }
    m_ckbOutputQuant->setChecked(bChecked);
    m_cmbOutputQuant->setCurrentIndex(nSel);
    m_cmbOutputQuant->setEnabled(bChecked);
    if(videoProcessSettings.quantRange == MWCAP_VIDEO_QUANTIZATION_UNKNOWN)
        g_capture.SetVideoQuant(videoSignalStatus.quantRange);
    else
        g_capture.SetVideoQuant(videoProcessSettings.quantRange);

    bChecked = true;
    nSel = 0;
    switch (videoProcessSettings.satRange)
    {
    case MWCAP_VIDEO_SATURATION_UNKNOWN:
        bChecked = false;
        switch (videoSignalStatus.satRange)
        {
        case MWCAP_VIDEO_SATURATION_FULL:
            nSel = 0;
            break;
        case MWCAP_VIDEO_SATURATION_LIMITED:
            nSel = 1;
            break;
        case MWCAP_VIDEO_SATURATION_EXTENDED_GAMUT:
            nSel = 2;
            break;
        }
        m_cmbOutputSaturation->setCurrentIndex(nSel);
        break;
    case MWCAP_VIDEO_SATURATION_FULL:
        nSel = 0;
        break;
    case MWCAP_VIDEO_SATURATION_LIMITED:
        nSel = 1;
        break;
    case MWCAP_VIDEO_SATURATION_EXTENDED_GAMUT:
        nSel = 2;
        break;
    }
    m_ckbOutputSaturation->setChecked(bChecked);
    m_cmbOutputSaturation->setCurrentIndex(nSel);
    m_cmbOutputSaturation->setEnabled(bChecked);
    if(videoProcessSettings.satRange == MWCAP_VIDEO_SATURATION_UNKNOWN)
        g_capture.SetVideoSaturation(videoSignalStatus.satRange);
    else
        g_capture.SetVideoSaturation(videoProcessSettings.satRange);

    nSel = 0;
    switch (videoProcessSettings.deinterlaceMode)
    {
    case MWCAP_VIDEO_DEINTERLACE_WEAVE:
        nSel = 0;
        break;
    case MWCAP_VIDEO_DEINTERLACE_BLEND:
        nSel = 1;
        break;
    case MWCAP_VIDEO_DEINTERLACE_TOP_FIELD:
        nSel = 2;
        break;
    case MWCAP_VIDEO_DEINTERLACE_BOTTOM_FIELD:
        nSel = 3;
        break;
    }
    m_cmbOutputDeint->setCurrentIndex(nSel);
    g_capture.SetVideoDeintMode(videoProcessSettings.deinterlaceMode);

    nSel = 0;
    switch (videoProcessSettings.aspectRatioConvertMode)
    {
    case MWCAP_VIDEO_ASPECT_RATIO_IGNORE:
        nSel = 0;
        break;
    case MWCAP_VIDEO_ASPECT_RATIO_CROPPING:
        nSel = 1;
        break;
    case MWCAP_VIDEO_ASPECT_RATIO_PADDING:
        nSel = 2;
        break;
    }
    m_cmbOutputAR->setCurrentIndex(nSel);
    g_capture.SetVideoARMode(videoProcessSettings.aspectRatioConvertMode);
}

void CDlgVideo::onInputSourceChanged(unsigned long long ullStatusBits)
{
    emit sigInputSourceChanged(ullStatusBits);
}

//input slots
void CDlgVideo::onInputAspectChecked(int nStatus)
{
    bool bCheck = (nStatus == Qt::Checked ? true : false);
    MWCAP_VIDEO_SIGNAL_STATUS videoSignalStatus;
    MW_RESULT nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoSignalStatus);
    if(videoSignalStatus.state != MWCAP_VIDEO_SIGNAL_LOCKED)
    {
        videoSignalStatus.nAspectX = 16;
        videoSignalStatus.nAspectY = 9;
    }

    int nIndex = g_capture.GetCurrentDeviceIndex();
    int nAspectX = 0;
    int nAspectY = 0;
    if (!bCheck)
    {
        m_bAspectDefault[nIndex] = false;
        nAspectX = videoSignalStatus.nAspectX;
        nAspectY = videoSignalStatus.nAspectY;
        nRet = MWSetVideoInputAspectRatio(g_capture.GetVideoHandle(), nAspectX, nAspectY);
        disconnect(m_spinInputAspectX, SIGNAL(valueChanged(int)), this, SLOT(onInputAspectXValueChanged(int )));
        disconnect(m_spinInputAspectY, SIGNAL(valueChanged(int)), this, SLOT(onInputAspectYValueChanged(int )));
        m_spinInputAspectX->setValue(videoSignalStatus.nAspectX);
        m_spinInputAspectY->setValue(videoSignalStatus.nAspectY);
        m_spinInputAspectX->setRange(1, 2048);
        m_spinInputAspectY->setRange(1, 2048);
        connect(m_spinInputAspectX, SIGNAL(valueChanged(int)), this, SLOT(onInputAspectXValueChanged(int )));
        connect(m_spinInputAspectY, SIGNAL(valueChanged(int)), this, SLOT(onInputAspectYValueChanged(int )));
    }
    else
        m_bAspectDefault[nIndex] = true;

    m_spinInputAspectX->setEnabled(bCheck);
    m_spinInputAspectY->setEnabled(bCheck);
    m_ckbInputAspect->setChecked(bCheck);

}

void CDlgVideo::onInputColorFormatChecked(int nStatus)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    bool bCheck = (nStatus == Qt::Checked ? true : false);
    MW_RESULT nRet;
    if (!bCheck) {
        MWCAP_VIDEO_SIGNAL_STATUS videoSignalStatus;
        nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoSignalStatus);

        nRet = MWSetVideoInputColorFormat(g_capture.GetVideoHandle(), videoSignalStatus.colorFormat);
        m_bColorfmtDefault[nIndex] = false;
        int nSel = 0;
        switch (videoSignalStatus.colorFormat)
        {
        case MWCAP_VIDEO_COLOR_FORMAT_RGB:
            nSel = 0;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV601:
            nSel = 1;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV709:
            nSel = 2;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV2020:
            nSel = 3;
            break;
        default:
            break;
        }
        disconnect(m_cmbInputColorFmt, SIGNAL(currentIndexChanged(int )), this, SLOT(onInputColorFormatIndexChanged(int )));
        m_cmbInputColorFmt->setCurrentIndex(nSel);
        connect(m_cmbInputColorFmt, SIGNAL(currentIndexChanged(int )), this, SLOT(onInputColorFormatIndexChanged(int )));
    }
    else
        m_bColorfmtDefault[nIndex] = true;

    m_cmbInputColorFmt->setEnabled(bCheck);
    m_ckbInputColorFmt->setChecked(bCheck);
}

void CDlgVideo::onInputQuantChecked(int nStatus)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    bool bCheck = nStatus == Qt::Checked ? true : false;
    MW_RESULT nRet;
    if (!bCheck) {
        MWCAP_VIDEO_SIGNAL_STATUS videoSignalStatus;
        nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoSignalStatus);

        nRet = MWSetVideoInputQuantizationRange(g_capture.GetVideoHandle(), videoSignalStatus.quantRange);
        m_bQuantDefault[nIndex] = false;
        int nSel = 0;
        switch (videoSignalStatus.quantRange)
        {
        case MWCAP_VIDEO_QUANTIZATION_FULL:
            nSel = 0;
            break;
        case MWCAP_VIDEO_QUANTIZATION_LIMITED:
            nSel = 1;
            break;
        default:
            break;
        }
        disconnect(m_cmbInputQuant, SIGNAL(currentIndexChanged(int )), this, SLOT(onInputQuantIndexChanged(int )));
        m_cmbInputQuant->setCurrentIndex(nSel);
        connect(m_cmbInputQuant, SIGNAL(currentIndexChanged(int )), this, SLOT(onInputQuantIndexChanged(int )));
    }
    else
        m_bQuantDefault[nIndex] = true;

    m_cmbInputQuant->setEnabled(bCheck);
    m_ckbInputQuant->setChecked(bCheck);
}

void CDlgVideo::onInputAspectXValueChanged(int nValue)
{
    MW_RESULT nRet = MWSetVideoInputAspectRatio(g_capture.GetVideoHandle(), nValue, m_spinInputAspectY->value());
    m_shFile->ModifyFileAspectXInput(nValue);

}

void CDlgVideo::onInputAspectYValueChanged(int nValue)
{
    MW_RESULT nRet = MWSetVideoInputAspectRatio(g_capture.GetVideoHandle(), m_spinInputAspectX->value(), nValue);
    m_shFile->ModifyFileAspectYInput(nValue);
}

void CDlgVideo::onInputColorFormatIndexChanged(int nIndex)
{
    int nSel = m_cmbInputColorFmt->currentIndex();
    MWCAP_VIDEO_COLOR_FORMAT videoColorFormat;
    switch (nSel)
    {
    case 0:
        videoColorFormat = MWCAP_VIDEO_COLOR_FORMAT_RGB;
        m_shFile->ModifyFileColorFmtInput("rgb");
        break;
    case 1:
        videoColorFormat = MWCAP_VIDEO_COLOR_FORMAT_YUV601;
        m_shFile->ModifyFileColorFmtInput("bt601");
        break;
    case 2:
        videoColorFormat = MWCAP_VIDEO_COLOR_FORMAT_YUV709;
        m_shFile->ModifyFileColorFmtInput("bt709");
        break;
    case 3:
        videoColorFormat = MWCAP_VIDEO_COLOR_FORMAT_YUV2020;
        m_shFile->ModifyFileColorFmtInput("bt2020");
        break;
    default:
        break;
    }

    MWSetVideoInputColorFormat(g_capture.GetVideoHandle(), videoColorFormat);

}

void CDlgVideo::onInputQuantIndexChanged(int nIndex)
{
    int nSel = m_cmbInputQuant->currentIndex();
    MWCAP_VIDEO_QUANTIZATION_RANGE quantRange;
    switch (nSel)
    {
    case 0:
        quantRange = MWCAP_VIDEO_QUANTIZATION_FULL;
        m_shFile->ModifyFileQuanInput("full");
        break;
    case 1:
        quantRange = MWCAP_VIDEO_QUANTIZATION_LIMITED;
        m_shFile->ModifyFileQuanInput("limited");
        break;
    default:
        break;
    }

    MWSetVideoInputQuantizationRange(g_capture.GetVideoHandle(), quantRange);

}

//output slots
void CDlgVideo::onOutputAspectChecked(int nStatus)
{
    bool bCheck = (nStatus == Qt::Checked ? true : false);
    int nAspectX = 0;
    int nAspectY = 0;
    MWCAP_VIDEO_SIGNAL_STATUS videoSignalStatus;
    MW_RESULT nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoSignalStatus);
    if(videoSignalStatus.state != MWCAP_VIDEO_SIGNAL_LOCKED)
    {
        nAspectX = 16;
        nAspectY = 9;
    }
    else
    {
        nAspectX = videoSignalStatus.nAspectX;
        nAspectY = videoSignalStatus.nAspectY;
    }

    if(!bCheck)
    {
        m_spinOutputAspectX->setValue(nAspectX);
        m_spinOutputAspectY->setValue(nAspectY);
        g_capture.SetVideoAspectX(nAspectX);
        g_capture.SetVideoAspectY(nAspectY);
    }

    m_spinOutputAspectX->setEnabled(bCheck);
    m_spinOutputAspectY->setEnabled(bCheck);
    m_ckbOutputAspect->setChecked(bCheck);

}

void CDlgVideo::onLowLatencyChecked(int nStatus)
{
    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);
    videoSettings.bLowLatency = ((nStatus == Qt::Checked) ? 1 : 0);
    g_capture.SetLowLatency(nStatus == Qt::Checked);
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputCropChecked(int nStatus)
{
    bool bCheck = (nStatus == Qt::Checked ? true : false);
    int left = 0;
    int top = 0;
    int right = 0;
    int bottom = 0;
    MWCAP_VIDEO_SIGNAL_STATUS videoSignalStatus;
    MW_RESULT nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoSignalStatus);
    if(videoSignalStatus.state != MWCAP_VIDEO_SIGNAL_LOCKED)
    {
        left = 0;
        top = 0;
        right = 1920;
        bottom = 1080;
    }
    else
    {
        left = 0;
        top = 0;
        right = videoSignalStatus.cx;
        bottom = videoSignalStatus.cy;
    }

    if(!bCheck)
    {
        m_spinOutputCropLeft->setValue(left);
        m_spinOutputCropTop->setValue(top);
        m_spinOutputCropRight->setValue(right);
        m_spinOutputCropBottom->setValue(bottom);
        RECT rectSource;
        rectSource.left = left;
        rectSource.top = top;
        rectSource.right = right;
        rectSource.bottom = bottom;
        g_capture.SetVideoCropRect(&rectSource);
    }

    m_spinOutputCropLeft->setEnabled(bCheck);
    m_spinOutputCropTop->setEnabled(bCheck);
    m_spinOutputCropRight->setEnabled(bCheck);
    m_spinOutputCropBottom->setEnabled(bCheck);
    m_ckbOutputCrop->setChecked(bCheck);
}

void CDlgVideo::onOutputColorFormatChecked(int nStatus)
{
    bool bCheck = (nStatus == Qt::Checked ? true : false);
    if (!bCheck)
    {
        MWCAP_VIDEO_SIGNAL_STATUS videoStatus;
        MW_RESULT nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoStatus);
        int nSel = 0;
        switch (videoStatus.colorFormat)
        {
        case MWCAP_VIDEO_COLOR_FORMAT_RGB:
            nSel = 0;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV601:
            nSel = 1;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV709:
            nSel = 2;
            break;
        case MWCAP_VIDEO_COLOR_FORMAT_YUV2020:
            nSel = 3;
            break;
        }
        m_cmbOutputColorFmt->setCurrentIndex(nSel);
        g_capture.SetVideoColorFormat(videoStatus.colorFormat);
    }

    m_cmbOutputColorFmt->setEnabled(bCheck);
    m_ckbOutputColorFmt->setChecked(bCheck);

}

void CDlgVideo::onOutputQuantChecked(int nStatus)
{
    bool bCheck = (nStatus == Qt::Checked ? true : false);
    if (!bCheck)
    {
        MWCAP_VIDEO_SIGNAL_STATUS videoStatus;
        MW_RESULT nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoStatus);
        int nSel = 0;
        switch (videoStatus.quantRange)
        {
        case MWCAP_VIDEO_QUANTIZATION_FULL:
            nSel = 0;
            break;
        case MWCAP_VIDEO_QUANTIZATION_LIMITED:
            nSel = 1;
            break;
        }
        m_cmbOutputQuant->setCurrentIndex(nSel);
        g_capture.SetVideoQuant(videoStatus.quantRange);
    }
    m_cmbOutputQuant->setEnabled(bCheck);
    m_ckbOutputQuant->setChecked(bCheck);
}

void CDlgVideo::onOutputSaturationChecked(int nStatus)
{
    bool bCheck = (nStatus == Qt::Checked ? true : false);
    if (!bCheck)
    {
        MWCAP_VIDEO_SIGNAL_STATUS videoStatus;
        MW_RESULT nRet = MWGetVideoSignalStatus(g_capture.GetVideoHandle(), &videoStatus);

        int nSel = 0;
        switch (videoStatus.satRange)
        {
        case MWCAP_VIDEO_SATURATION_FULL:
            nSel = 0;
            break;
        case MWCAP_VIDEO_SATURATION_LIMITED:
            nSel = 1;
            break;
        case MWCAP_VIDEO_SATURATION_EXTENDED_GAMUT:
            nSel = 2;
            break;
        }
        m_cmbOutputSaturation->setCurrentIndex(nSel);
        g_capture.SetVideoSaturation(videoStatus.satRange);
    }

    m_cmbOutputSaturation->setEnabled(bCheck);
    m_ckbOutputSaturation->setChecked(bCheck);

}

void CDlgVideo::onOutputAspectXValueChanged(int nValue)
{
    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);
    videoSettings.nAspectX = nValue;
    videoSettings.nAspectY = m_spinOutputAspectY->value();
    g_capture.SetVideoAspectX(nValue);
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputAspectYValueChanged(int nValue)
{
    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);
    videoSettings.nAspectY = nValue;
    videoSettings.nAspectX = m_spinOutputAspectX->value();
    g_capture.SetVideoAspectY(nValue);
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputCropLeft(int nValue)
{
    RECT rect = {nValue, m_spinOutputCropTop->value(), m_spinOutputCropRight->value(), m_spinOutputCropBottom->value()};
    g_capture.SetVideoCropRect(&rect);

    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);
    videoSettings.rectSource = rect;
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputCropTop(int nValue)
{
    RECT rect = {m_spinOutputCropLeft->value(), nValue, m_spinOutputCropRight->value(), m_spinOutputCropBottom->value()};
    g_capture.SetVideoCropRect(&rect);

    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);
    videoSettings.rectSource = rect;
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputCropRight(int nValue)
{
    RECT rect = {m_spinOutputCropLeft->value(), m_spinOutputCropTop->value(), nValue, m_spinOutputCropBottom->value()};
    g_capture.SetVideoCropRect(&rect);

    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);
    videoSettings.rectSource = rect;
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputCropBottom(int nValue)
{
    RECT rect = {m_spinOutputCropLeft->value(), m_spinOutputCropTop->value(), m_spinOutputCropRight->value(), nValue};
    g_capture.SetVideoCropRect(&rect);

    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);
    videoSettings.rectSource = rect;
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputColorFormatIndexChanged(int nIndex)
{
    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);

    int nSel = m_cmbOutputColorFmt->currentIndex();
    switch (nSel)
    {
    case 0:
        videoSettings.colorFormat = MWCAP_VIDEO_COLOR_FORMAT_RGB;
        break;
    case 1:
        videoSettings.colorFormat = MWCAP_VIDEO_COLOR_FORMAT_YUV601;
        break;
    case 2:
        videoSettings.colorFormat = MWCAP_VIDEO_COLOR_FORMAT_YUV709;
        break;
    case 3:
        videoSettings.colorFormat = MWCAP_VIDEO_COLOR_FORMAT_YUV2020;
        break;
    default:
        break;
    }
    g_capture.SetVideoColorFormat(videoSettings.colorFormat);
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputQuantIndexChanged(int nIndex)
{
    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);

    int nSel = m_cmbOutputQuant->currentIndex();
    switch (nSel)
    {
    case 0:
        videoSettings.quantRange = MWCAP_VIDEO_QUANTIZATION_FULL;
        break;
    case 1:
        videoSettings.quantRange = MWCAP_VIDEO_QUANTIZATION_LIMITED;
        break;
    default:
        break;
    }
    g_capture.SetVideoQuant(videoSettings.quantRange);
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutSaturationIndexChanged(int nIndex)
{
    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);

    int nSel = m_cmbOutputSaturation->currentIndex();
    switch (nSel)
    {
    case 0:
        videoSettings.satRange = MWCAP_VIDEO_SATURATION_FULL;
        break;
    case 1:
        videoSettings.satRange = MWCAP_VIDEO_SATURATION_LIMITED;
        break;
    case 2:
        videoSettings.satRange = MWCAP_VIDEO_SATURATION_EXTENDED_GAMUT;
        break;
    default:
        break;
    }
    g_capture.SetVideoSaturation(videoSettings.satRange);
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputDeintIndexChanged(int nIndex)
{
    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);

    int nSel = m_cmbOutputDeint->currentIndex();
    switch (nSel)
    {
    case 0:
        videoSettings.deinterlaceMode = MWCAP_VIDEO_DEINTERLACE_WEAVE;
        break;
    case 1:
        videoSettings.deinterlaceMode = MWCAP_VIDEO_DEINTERLACE_BLEND;
        break;
    case 2:
        videoSettings.deinterlaceMode = MWCAP_VIDEO_DEINTERLACE_TOP_FIELD;
        break;
    case 3:
        videoSettings.deinterlaceMode = MWCAP_VIDEO_DEINTERLACE_BOTTOM_FIELD;
        break;
    default:
        break;
    }
    g_capture.SetVideoDeintMode(videoSettings.deinterlaceMode);
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onOutputARIndexChanged(int nIndex)
{
    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);

    int nSel = m_cmbOutputAR->currentIndex();
    switch (nSel)
    {
    case 0:
        videoSettings.aspectRatioConvertMode = MWCAP_VIDEO_ASPECT_RATIO_IGNORE;
        break;
    case 1:
        videoSettings.aspectRatioConvertMode = MWCAP_VIDEO_ASPECT_RATIO_CROPPING;
        break;
    case 2:
        videoSettings.aspectRatioConvertMode = MWCAP_VIDEO_ASPECT_RATIO_PADDING;
        break;
    default:
        break;
    }
    g_capture.SetVideoARMode(videoSettings.aspectRatioConvertMode);
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);
}

void CDlgVideo::onLoadPresetClicked(bool bFlag)
{
    int nChannelIndex = g_capture.GetCurrentDeviceIndex();
    MWSetVideoProcessSettings(g_capture.GetVideoHandle(), m_videoSettings[nChannelIndex]);
    UpdateOutputSettings();
}

void CDlgVideo::onSavePresetClicked(bool bFlag)
{
    MWCAP_VIDEO_PROCESS_SETTINGS videoSettings;
    MW_RESULT nRet = MWGetVideoProcessSettings(g_capture.GetVideoHandle(), &videoSettings);

    RECT rect1 = {0};
    RECT rect2 = {m_spinOutputCropLeft->value(), m_spinOutputCropTop->value(), m_spinOutputCropRight->value(), m_spinOutputCropBottom->value()};
    videoSettings.rectSource = !m_ckbOutputCrop->isChecked() ? rect1 : rect2;
    videoSettings.nAspectX = !m_ckbOutputAspect->isChecked() ? 0 : m_spinOutputAspectX->value();
    videoSettings.nAspectY = !m_ckbOutputAspect->isChecked() ? 0 : m_spinOutputAspectY->value();
    videoSettings.bLowLatency = m_ckbOutputLowlatency->isChecked();
    videoSettings.colorFormat = !m_ckbOutputColorFmt->isChecked() ? MWCAP_VIDEO_COLOR_FORMAT_UNKNOWN : (MWCAP_VIDEO_COLOR_FORMAT) (m_cmbOutputColorFmt->currentIndex() + 1);
    videoSettings.quantRange = !m_ckbOutputQuant->isChecked() ? MWCAP_VIDEO_QUANTIZATION_UNKNOWN : (MWCAP_VIDEO_QUANTIZATION_RANGE) (m_cmbOutputQuant->currentIndex() + 1);
    videoSettings.satRange = !m_ckbOutputSaturation->isChecked() ? MWCAP_VIDEO_SATURATION_UNKNOWN : (MWCAP_VIDEO_SATURATION_RANGE) (m_cmbOutputSaturation->currentIndex() + 1);
    videoSettings.deinterlaceMode = (MWCAP_VIDEO_DEINTERLACE_MODE) (m_cmbOutputDeint->currentIndex());
    videoSettings.aspectRatioConvertMode = (MWCAP_VIDEO_ASPECT_RATIO_CONVERT_MODE) (m_cmbOutputAR->currentIndex());
//    nRet = MWSetVideoProcessSettings(g_capture.GetVideoHandle(), videoSettings);

    int nChannelIndex = g_capture.GetCurrentDeviceIndex();
    memcpy(&m_videoSettings[nChannelIndex], &videoSettings, sizeof(MWCAP_VIDEO_PROCESS_SETTINGS));
}

void CDlgVideo::onInputSourceChangedMain(unsigned long long ullStatusBits)
{
    if ((ullStatusBits & MWCAP_NOTIFY_VIDEO_INPUT_SOURCE_CHANGE) != 0 || (ullStatusBits & MWCAP_NOTIFY_VIDEO_SIGNAL_CHANGE) != 0) {
        UpdateVideoSettings();
    }
}
