#ifndef CGENERATESHFILE_H
#define CGENERATESHFILE_H

#include <QWidget>
#include <QProcess>
#include <QFile>
#include <QTextStream>
#include <QStandardPaths>
#include "cvideochannel.h"

class CGenerateSHFile : public QProcess
{
    Q_OBJECT
public:
    explicit CGenerateSHFile(QWidget *parent = 0);

    //device name
    void ModifySHFileDeviceName(int nIndex);
    void ModifySHfileOutput(MWCAP_VIDEO_PROCESS_SETTINGS videoSettings);

    //input
    void ModifyFileVideoInputType(char *type);
    void ModifyFileAudioInputType(char *type);
    void ModifyFileAutoScan(char * pAutoScan);
    void ModifyFileLinkWithVideo(char *pLinkWithVideo);

    //video
    void ModifyFileAspectXInput(int nValue);
    void ModifyFileAspectYInput(int nValue);
    void ModifyFileColorFmtInput(char *pFormat);
    void ModifyFileQuanInput(char *pQuan);
    void ModifyFileLowlatency(char *pValue);
//    void ModifyFileARConvertion(char *pValue);

    //timing
    void ModifyFileSaveTimingSettings();
    void ModifyFileAutoSamp(char * pAutoSampl);
    void ModifyFileAutoHAlign(char * pAutoHAlign);
    void ModifyFileSetPhase(int nValue);

    //edid
    void ModifyFileSaveEdid();

private:

    int     m_nDeviceIndex;
    //device
    char    m_szDeviceName[_MAX_PATH];
    QString m_strPath;
};

#endif // CGENERATESHFILE_H
